import { Animated, ViewStyle } from 'react-native';
interface AnimationConfig {
    easing?: (value: number) => number;
    deceleration?: number;
    duration?: number;
    delay?: number;
    useNativeDriver?: boolean;
}
export interface ToasterAnimation {
    forward: () => Promise<Animated.EndResult>;
    backward: () => Promise<Animated.EndResult>;
    readonly styles: Animated.WithAnimatedObject<ViewStyle>;
}
export declare class BaseAnimation {
    config: AnimationConfig;
    from: number;
    to: number;
    value: Animated.Value;
    constructor(from: number, to: number, config?: AnimationConfig);
    forward: () => Promise<Animated.EndResult>;
    backward: () => Promise<Animated.EndResult>;
}
export {};
