"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toaster = void 0;
const React = require("react");
const react_native_1 = require("react-native");
const Toast_1 = require("../Toast");
const TouchController_1 = require("../TouchController");
const useToaster_1 = require("./useToaster");
const styles_1 = require("./styles");
const Toaster = (_a) => {
    var _b;
    var { containerViewProps, children } = _a, props = __rest(_a, ["containerViewProps", "children"]);
    const { onHoldStart, onHoldEnd, onPress, activeToastItem, } = (0, useToaster_1.useToaster)(props);
    return (React.createElement(react_native_1.Animated.View, Object.assign({}, containerViewProps, { style: [styles_1.styles.container, containerViewProps === null || containerViewProps === void 0 ? void 0 : containerViewProps.style, (_b = props.animation) === null || _b === void 0 ? void 0 : _b.styles] }),
        React.createElement(TouchController_1.TouchController, { onHoldStart: onHoldStart, onHoldEnd: onHoldEnd, onPress: onPress }, activeToastItem && ((children === null || children === void 0 ? void 0 : children(activeToastItem)) || (React.createElement(Toast_1.Toast, { type: activeToastItem.type, message: activeToastItem.message }))))));
};
exports.Toaster = Toaster;
exports.Toaster.info = useToaster_1.StaticMethods.info;
exports.Toaster.error = useToaster_1.StaticMethods.error;
exports.Toaster.debug = useToaster_1.StaticMethods.debug;
exports.Toaster.success = useToaster_1.StaticMethods.success;
