import { ToasterAnimation } from '../../animations';
import { ToastType } from '../Toast';
export interface Item {
    type: ToastType;
    message: string;
    duration?: number;
}
export interface UseToasterParams {
    onHide?: (item: Item) => void;
    onShow?: (item: Item) => void;
    onPress?: (event: unknown, item: Item) => void;
    onHoldEnd?: (event: unknown, item: Item) => void;
    onHoldStart?: (event: unknown, item: Item) => void;
    animation?: ToasterAnimation;
    duration?: number;
    delayBetween?: number;
    middleware?: (item: Item) => string;
    hideOnPress?: boolean;
}
export declare const useToaster: ({ onHide, onShow, onPress: onPressProp, onHoldEnd: onHoldEndProp, onHoldStart: onHoldStartProp, animation, duration, delayBetween, middleware, hideOnPress, }: UseToasterParams) => {
    activeToastItem: Item;
    onHoldStart: (event: unknown) => void;
    onHoldEnd: (event: unknown) => void;
    onPress: (event: unknown) => void;
};
type StaticMethod = (message: string, duration?: number) => void;
export interface StaticMethods {
    info: StaticMethod;
    error: StaticMethod;
    success: StaticMethod;
    debug: StaticMethod;
}
export declare const StaticMethods: StaticMethods;
export {};
